/*
   Based on "Principles of Parallel Programming", page 16.
*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int * array;
int length;
int count;

void count3s()
{
   int i;
   count = 0;
   for(i = 0; i < length; i++)
   {
      if(array[i] == 3)
      {
         count++;
      }
   }
}


int main(int argc, char *argv[])
{
   int i;
   length = 1048576;  /*  2^20  */

   array = calloc(length, sizeof(int));

   /* initialize the array with random integers between 0 and 9 */
   srand(time(NULL));  /* seed the random number generator with current time */
   for(i = 0; i < length; i++)
   {
      array[i] = rand()%10;
   }

   count3s();  /* call the function */

   printf("The number of 3's is %d\n", count);

   return 0;
}